﻿using System;
using System.Collections.Generic;

public partial class _Default : System.Web.UI.Page
{
    static Queue<string> QueueData;

    /// <summary>
    /// Page Load Event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        txtMSG.Text = "";
        txtQueue.Text = "";
        if (!IsPostBack)
        {
            QueueData = new Queue<string>();
            QueueData.Enqueue("299");
            QueueData.Enqueue("399");
            DisplayQueueData();
        }

        //Uncomment in case of other functionalities.
        // OtherFunctionality();
    }

    /// <summary>
    /// Display Queue Data
    /// </summary>
    private void DisplayQueueData()
    {
        foreach (string QueueItem in QueueData)
        {
            txtQueue.Text += ", " + QueueItem;
        }

        txtQueue.Text = txtQueue.Text.TrimStart(',');
    }

    /// <summary>
    /// Queue - Other Operations
    /// </summary>
    private void OtherFunctionality()
    {


        ////Clear all the items of Queue
        QueueData.Clear();

        txtMSG.Text = " Count of All the Items of Queue: " + QueueData.Count;

        //Check first element of Queue without removing it.
        txtMSG.Text = " First element of Queue: " + QueueData.Peek();

    }

    /// <summary>
    /// Queue - Enqueue Operation
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnEnqueue_Click(object sender, EventArgs e)
    {
        if (txtItem.Text.Trim() != "")
        {
            string QueueItem = txtItem.Text.Trim();
            QueueData.Enqueue(QueueItem);

            txtMSG.Text = QueueItem + " - Enqueue Complete.";
        }
        else
        {
            txtMSG.Text = "Enter an Item.";
        }
        DisplayQueueData();
    }

    /// <summary>
    /// Queue - Dequeue Operation
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDequeue_Click(object sender, EventArgs e)
    {
        if (QueueData.Count > 0)
        {
            string QueueItem = QueueData.Dequeue();
            txtMSG.Text = QueueItem + " - Dequeue Complete.";

        }
        else
        {
            txtMSG.Text = "Queue is Empty.";
        }

        DisplayQueueData();
    }

    /// <summary>
    /// Queue  - Copy to Array
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnCopytoArray_Click(object sender, EventArgs e)
    {
        string[] strArray = new string[QueueData.Count];
        QueueData.CopyTo(strArray, 0);

        foreach (string ArrayItem in strArray)
        {
            txtMSG.Text += ", " + ArrayItem;
        }

        txtMSG.Text = "Item Copied- " + txtMSG.Text.TrimStart(',');

    }

    /// <summary>
    /// Queue - Search Operation
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        bool blnFlag = false;
        foreach (string QueueItem in QueueData)
        {
            if (QueueItem == txtItem.Text.Trim())
            {
                blnFlag = true;
                break;
            }
        }

        if (blnFlag)
        {
            txtMSG.Text = txtItem.Text.Trim() + " Found in Queue.";
        }
        else
        {
            txtMSG.Text = txtItem.Text.Trim() + " Not Found in Queue.";
        }

        //Inbuilt method for search
        // QueueData.Contains(txtItem.Text.Trim());

        DisplayQueueData();
    }
}
